#pragma once
#include <wtypes.h>
#include "CyAPI.h"
#include <dbt.h>

namespace Firmware_download {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Security::Permissions;
	using namespace System::IO;

#define ERR_INFILE			"Unable to open input file."
#define ERR_INVALID_FILE	"The input file is not a valid hex file."
#define ERR_BAD_CHKSUM		"The input file contains a bad checksum."

#define MEMORY_BUFFER_SIZE		0x10000
#define MAX_INTERNAL_MEMORY		0x2000
#define MEM_FILL				0xaa
#define RECORDSIZE				4096
#define CPU_RESET_REGISTER_FX2LP	0xE600
#define CPU_RESET_REGISTER_FX		0x7F92

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>

	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();

			bPnP_Arrival		= false;							//Initializing the variables
			bPnP_Removal		= false;
			bPnP_DevNodeChange	= false;
			Selected_Index = 0;
			FX2LP_OR_FX->SelectedIndex = 0;
			FX2LP = TRUE;
			CPU_RESET_REGISTER = CPU_RESET_REGISTER_FX2LP;
			FirstTime = TRUE;
			GetDevice();

			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::ComboBox^  Device_List;
	protected: 
	private: System::Windows::Forms::TextBox^  Download_Data;
	private: System::Windows::Forms::Button^  Download_Firmware;
	private: System::Windows::Forms::OpenFileDialog^  FOpenDialog;
	private: System::Windows::Forms::ComboBox^  FX2LP_OR_FX;
	private: System::Windows::Forms::Button^  Clear;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->Device_List = (gcnew System::Windows::Forms::ComboBox());
			this->Download_Data = (gcnew System::Windows::Forms::TextBox());
			this->Download_Firmware = (gcnew System::Windows::Forms::Button());
			this->FOpenDialog = (gcnew System::Windows::Forms::OpenFileDialog());
			this->FX2LP_OR_FX = (gcnew System::Windows::Forms::ComboBox());
			this->Clear = (gcnew System::Windows::Forms::Button());
			this->SuspendLayout();
			// 
			// Device_List
			// 
			this->Device_List->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->Device_List->FormattingEnabled = true;
			this->Device_List->Location = System::Drawing::Point(29, 23);
			this->Device_List->Name = L"Device_List";
			this->Device_List->Size = System::Drawing::Size(284, 21);
			this->Device_List->TabIndex = 0;
			this->Device_List->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::Device_List_SelectedIndexChanged);
			// 
			// Download_Data
			// 
			this->Download_Data->Font = (gcnew System::Drawing::Font(L"Courier New", 8.25F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->Download_Data->Location = System::Drawing::Point(29, 72);
			this->Download_Data->Multiline = true;
			this->Download_Data->Name = L"Download_Data";
			this->Download_Data->ScrollBars = System::Windows::Forms::ScrollBars::Vertical;
			this->Download_Data->Size = System::Drawing::Size(434, 355);
			this->Download_Data->TabIndex = 1;
			// 
			// Download_Firmware
			// 
			this->Download_Firmware->Location = System::Drawing::Point(90, 446);
			this->Download_Firmware->Name = L"Download_Firmware";
			this->Download_Firmware->Size = System::Drawing::Size(108, 37);
			this->Download_Firmware->TabIndex = 2;
			this->Download_Firmware->Text = L"Download Firmware";
			this->Download_Firmware->UseVisualStyleBackColor = true;
			this->Download_Firmware->Click += gcnew System::EventHandler(this, &Form1::Download_Firmware_Click);
			// 
			// FX2LP_OR_FX
			// 
			this->FX2LP_OR_FX->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->FX2LP_OR_FX->FormattingEnabled = true;
			this->FX2LP_OR_FX->Items->AddRange(gcnew cli::array< System::Object^  >(2) {L"FX2LP", L"FX"});
			this->FX2LP_OR_FX->Location = System::Drawing::Point(336, 23);
			this->FX2LP_OR_FX->Name = L"FX2LP_OR_FX";
			this->FX2LP_OR_FX->Size = System::Drawing::Size(127, 21);
			this->FX2LP_OR_FX->TabIndex = 3;
			this->FX2LP_OR_FX->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::FX2LP_OR_FX_SelectedIndexChanged);
			// 
			// Clear
			// 
			this->Clear->Location = System::Drawing::Point(282, 446);
			this->Clear->Name = L"Clear";
			this->Clear->Size = System::Drawing::Size(108, 37);
			this->Clear->TabIndex = 4;
			this->Clear->Text = L"Clear";
			this->Clear->UseVisualStyleBackColor = true;
			this->Clear->Click += gcnew System::EventHandler(this, &Form1::Clear_Click);
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(489, 495);
			this->Controls->Add(this->Clear);
			this->Controls->Add(this->FX2LP_OR_FX);
			this->Controls->Add(this->Download_Firmware);
			this->Controls->Add(this->Download_Data);
			this->Controls->Add(this->Device_List);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"Form1";
			this->Text = L"EZ-USB Firmware download utility";
			this->ResumeLayout(false);
			this->PerformLayout();

		}

		CCyUSBDevice				*USBDevice;
		CCyControlEndPoint			*ept;

		bool						bPnP_Arrival;
		bool						bPnP_Removal;
		bool						bPnP_DevNodeChange;
		bool						FX2LP;
		bool						FirstTime;
		int							Selected_Index;
		WORD						CPU_RESET_REGISTER;
		static ArrayList VendAX = gcnew ArrayList;

		void GetDevice()													//Function used to get handle to devices connected to CyUSB.sys
		{
			Device_List->Items->Clear();
			USBDevice = new CCyUSBDevice((HANDLE)this->Handle,CYUSBDRV_GUID,true);		//Opening an instance of CCyUSBDevice using the default GUID of CyUSB.sys

			if (!USBDevice) return;

			int n = USBDevice->DeviceCount();								//Handling the GUI behavior based on number of devices connected
			if(n == 0) 
			{
				Download_Firmware->Enabled = FALSE;
				return;
			}
			Download_Firmware->Enabled = TRUE;

			for (int i=0; i<n; i++)
			{
				USBDevice->Open(i);											//Opening each device to populate the Device_List dropdown list
				if(USBDevice != NULL)
				{
					String^ s = gcnew String(USBDevice->FriendlyName);
					Device_List->Items->Add(s);
				}
			}
			USBDevice->Open(0);												//Opening a handle to device 0
			Device_List->SelectedIndex = 0;
			ept = USBDevice->ControlEndPt;
		}

		void Error(String^ err)												//Error pop-up displaying function
		{
			MessageBox::Show("Error: " + err);
			exit(2);
		}

#pragma endregion
	private: System::Void Download_Firmware_Click(System::Object^  sender, System::EventArgs^  e) {
				 FOpenDialog->Title = "Select the firmware (.hex) to download";
				 FOpenDialog->Filter = "Firmware file (*.hex) | *.hex";
				 FOpenDialog->ShowDialog();
				 if(FOpenDialog->FileName !="")								//Pop-up window for selecting the firmware to be downloaded
				 {
					 FirstTime = TRUE;
					 Firmware_download(FOpenDialog->FileName);
				 }
			 }
			 
	private:
		void InitVendAX(bool FX2LP)											//Initializes the VendAX array based on target device (FX2LP/FX1 or FX/AN2131 etc)
		{
			if(FX2LP)														//Vend_ax firmware for FX2LP in the form of array
			{
				VendAX.Add(":0A0D3E00000102020303040405058E");
				VendAX.Add(":10064D00E4F52CF52BF52AF529C203C200C202C22E");
				VendAX.Add(":10065D0001120C6C7E0A7F008E0A8F0B75120A75C3");
				VendAX.Add(":10066D00131275080A75091C75100A75114A75144F");
				VendAX.Add(":10067D000A751578EE54C07003020752752D00757A");
				VendAX.Add(":10068D002E808E2F8F30C3749A9FFF740A9ECF24B5");
				VendAX.Add(":10069D0002CF3400FEE48F288E27F526F525F524AC");
				VendAX.Add(":1006AD00F523F522F521AF28AE27AD26AC25AB24D9");
				VendAX.Add(":1006BD00AA23A922A821C3120D035037E530252402");
				VendAX.Add(":1006CD00F582E52F3523F583E0FFE52E2524F58210");
				VendAX.Add(":1006DD00E52D3523F583EFF0E4FAF9F8E52424014F");
				VendAX.Add(":1006ED00F524EA3523F523E93522F522E83521F500");
				VendAX.Add(":1006FD002180B3852D0A852E0B74002480FF740A8A");
				VendAX.Add(":10070D0034FFFEC3E5139FF513E5129EF512C3E505");
				VendAX.Add(":10071D000D9FF50DE50C9EF50CC3E50F9FF50FE54F");
				VendAX.Add(":10072D000E9EF50EC3E5099FF509E5089EF508C374");
				VendAX.Add(":10073D00E5119FF511E5109EF510C3E5159FF51513");
				VendAX.Add(":10074D00E5149EF514D2E843D82090E668E04409FC");
				VendAX.Add(":10075D00F090E65CE0443DF0D2AF90E680E054F7D7");
				VendAX.Add(":10076D00F0538EF8C2031207FF30010512039AC22F");
				VendAX.Add(":10077D00013003F2120D6450EDC203120C0D200076");
				VendAX.Add(":10078D001690E682E030E704E020E1EF90E682E0AB");
				VendAX.Add(":0F079D0030E604E020E0E4120BB6120D6680C7D0");
				VendAX.Add(":0107AC00222A");
				VendAX.Add(":0B0D330090E50DE030E402C322D32263");
				VendAX.Add(":10039A0090E6B9E0700302048514700302052E2466");
				VendAX.Add(":1003AA00FE70030205C424FB700302047F14700369");
				VendAX.Add(":1003BA0002047914700302046D1470030204732496");
				VendAX.Add(":1003CA00056003020639120D68400302064590E6ED");
				VendAX.Add(":1003DA00BBE024FE603B14605624FD6016146040A6");
				VendAX.Add(":1003EA0024067075E50A90E6B3F0E50B90E6B4F0E2");
				VendAX.Add(":1003FA00020645120D33500FE51290E6B3F0E513ED");
				VendAX.Add(":10040A0090E6B4F002064590E6A0E04401F0020648");
				VendAX.Add(":10041A0045E50C90E6B3F0E50D90E6B4F00206452A");
				VendAX.Add(":10042A00E50E90E6B3F0E50F90E6B4F002064590CB");
				VendAX.Add(":10043A00E6BAE0FF120BE2AA06A9077B01EA494BDA");
				VendAX.Add(":10044A00600DEE90E6B3F0EF90E6B4F00206459048");
				VendAX.Add(":10045A00E6A0E04401F002064590E6A0E04401F07F");
				VendAX.Add(":10046A00020645120CF1020645120D50020645120B");
				VendAX.Add(":10047A000D48020645120CDF020645120D6A4003BA");
				VendAX.Add(":10048A0002064590E6B8E0247F602B14603C240203");
				VendAX.Add(":10049A006003020524A200E433FF25E0FFA202E480");
				VendAX.Add(":1004AA00334F90E740F0E4A3F090E68AF090E68BB1");
				VendAX.Add(":1004BA007402F0020645E490E740F0A3F090E68A61");
				VendAX.Add(":1004CA00F090E68B7402F002064590E6BCE0547E9A");
				VendAX.Add(":1004DA00FF7E00E0D3948040067C007D0180047C8E");
				VendAX.Add(":1004EA00007D00EC4EFEED4F243EF582740D3EF584");
				VendAX.Add(":1004FA0083E493FF3395E0FEEF24A1FFEE34E68F09");
				VendAX.Add(":10050A0082F583E0540190E740F0E4A3F090E68A94");
				VendAX.Add(":10051A00F090E68B7402F002064590E6A0E04401F2");
				VendAX.Add(":10052A00F0020645120D6C400302064590E6B8E05B");
				VendAX.Add(":10053A0024FE601D2402600302064590E6BAE0B478");
				VendAX.Add(":10054A000105C20002064590E6A0E04401F0020659");
				VendAX.Add(":10055A004590E6BAE0705990E6BCE0547EFF7E0012");
				VendAX.Add(":10056A00E0D3948040067C007D0180047C007D00FD");
				VendAX.Add(":10057A00EC4EFEED4F243EF582740D3EF583E49376");
				VendAX.Add(":10058A00FF3395E0FEEF24A1FFEE34E68F82F58378");
				VendAX.Add(":10059A00E054FEF090E6BCE05480FF131313541F9E");
				VendAX.Add(":1005AA00FFE0540F2F90E683F0E04420F002064566");
				VendAX.Add(":1005BA0090E6A0E04401F0020645120D6E507C90D0");
				VendAX.Add(":1005CA00E6B8E024FE60202402705B90E6BAE0B44C");
				VendAX.Add(":1005DA000104D200806590E6BAE06402605D90E6AC");
				VendAX.Add(":1005EA00A0E04401F0805490E6BCE0547EFF7E0017");
				VendAX.Add(":1005FA00E0D3948040067C007D0180047C007D006D");
				VendAX.Add(":10060A00EC4EFEED4F243EF582740D3EF583E493E5");
				VendAX.Add(":10061A00FF3395E0FEEF24A1FFEE34E68F82F583E7");
				VendAX.Add(":10062A00E04401F0801590E6A0E04401F0800C124D");
				VendAX.Add(":10063A000080500790E6A0E04401F090E6A0E04474");
				VendAX.Add(":02064A0080F03E");
				VendAX.Add(":01064C00228B");
				VendAX.Add(":03003300020D605B");
				VendAX.Add(":040D600053D8EF3243");
				VendAX.Add(":100C6C00D200E4F51A90E678E05410FFC4540F4417");
				VendAX.Add(":090C7C0050F51713E433F51922B9");
				VendAX.Add(":0107FF0022D7");
				VendAX.Add(":020D6400D32298");
				VendAX.Add(":020D6600D32296");
				VendAX.Add(":020D6800D32294");
				VendAX.Add(":080D480090E6BAE0F518D32291");
				VendAX.Add(":100CDF0090E740E518F0E490E68AF090E68B04F098");
				VendAX.Add(":020CEF00D3220E");
				VendAX.Add(":080D500090E6BAE0F516D3228B");
				VendAX.Add(":100CF10090E740E516F0E490E68AF090E68B04F088");
				VendAX.Add(":020D0100D322FB");
				VendAX.Add(":020D6A00D32292");
				VendAX.Add(":020D6C00D32290");
				VendAX.Add(":020D6E00D3228E");
				VendAX.Add(":1000800090E6B9E0245EB40B0040030203989000B0");
				VendAX.Add(":100090009C75F003A4C58325F0C583730201920209");
				VendAX.Add(":1000A000019202010D0200BD0200D70200F302011D");
				VendAX.Add(":1000B0003C02018C02011602012902016290E74014");
				VendAX.Add(":1000C000E519F0E490E68AF090E68B04F090E6A063");
				VendAX.Add(":1000D000E04480F002039890E60AE090E740F0E404");
				VendAX.Add(":1000E00090E68AF090E68B04F090E6A0E04480F081");
				VendAX.Add(":1000F00002039890E740740FF0E490E68AF090E6EF");
				VendAX.Add(":100100008B04F090E6A0E04480F002039890E6BAF9");
				VendAX.Add(":10011000E0F51702039890E67AE054FEF0E490E6EA");
				VendAX.Add(":100120008AF090E68BF002039890E67AE04401F0C2");
				VendAX.Add(":10013000E490E68AF090E68BF002039890E7407432");
				VendAX.Add(":1001400007F0E490E68AF090E68B04F090E6A0E0F9");
				VendAX.Add(":100150004480F07FE87E031207ADD204120B8702C1");
				VendAX.Add(":10016000039890E6B5E054FEF090E6BFE090E68A92");
				VendAX.Add(":10017000F090E6BEE090E68BF090E6BBE090E6B350");
				VendAX.Add(":10018000F090E6BAE090E6B4F002039875190143E6");
				VendAX.Add(":10019000170190E6BAE0753100F532A3E0FEE4EE17");
				VendAX.Add(":1001A000423190E6BEE0753300F534A3E0FEE4EEA4");
				VendAX.Add(":1001B000423390E6B8E064C06003020282E5344551");
				VendAX.Add(":1001C00033700302039890E6A0E020E1F9C3E53420");
				VendAX.Add(":1001D0009440E533940050088533358534368006E5");
				VendAX.Add(":1001E00075350075364090E6B9E0B4A335E4F537CF");
				VendAX.Add(":1001F000F538C3E5389536E53795355060E5322555");
				VendAX.Add(":1002000038F582E5313537F583E0FF74402538F560");
				VendAX.Add(":1002100082E434E7F583EFF00538E53870020537FE");
				VendAX.Add(":1002200080D0E4F537F538C3E5389536E5379535B0");
				VendAX.Add(":10023000501874402538F582E434E7F58374CDF026");
				VendAX.Add(":100240000538E5387002053780DDAD367AE779404C");
				VendAX.Add(":100250007EE77F40AB07AF32AE311208B8E490E6DC");
				VendAX.Add(":100260008AF090E68BE536F02532F532E53535310A");
				VendAX.Add(":10027000F531C3E5349536F534E5339535F533027C");
				VendAX.Add(":1002800001BD90E6B8E064406003020398E51A708F");
				VendAX.Add(":10029000051209678F1AE53445337003020398E4A9");
				VendAX.Add(":1002A00090E68AF090E68BF090E6A0E020E1F990ED");
				VendAX.Add(":1002B000E68BE0753500F53690E6B9E0B4A338E496");
				VendAX.Add(":1002C000F537F538C3E5389536E5379535400302FF");
				VendAX.Add(":1002D000037C74402538F582E434E7F583E0FFE5DC");
				VendAX.Add(":1002E000322538F582E5313537F583EFF00538E50D");
				VendAX.Add(":1002F000387002053780CDE4F537F538C3E5389519");
				VendAX.Add(":0703000036E5379535507515");
				VendAX.Add(":10030700851A39E51A64016044E5322538FFE5317D");
				VendAX.Add(":100317003537FEE51A24FFFDE434FF5EFEEF5D4E40");
				VendAX.Add(":100327006010E5322538FFE51A145FFFC3E51A9F11");
				VendAX.Add(":10033700F539C3E5369538FFE5359537FEC3EF95B3");
				VendAX.Add(":1003470039EE94005007C3E5369538F539E532257F");
				VendAX.Add(":1003570038FFE5313537FE74402538F582E434E758");
				VendAX.Add(":10036700AD82FCAB39120A9CE5392538F538E435FE");
				VendAX.Add(":0303770037F53720");
				VendAX.Add(":10037A008080E5362532F532E5353531F531C3E58C");
				VendAX.Add(":0F038A00349536F534E5339535F533020296C3D5");
				VendAX.Add(":010399002241");
				VendAX.Add(":100C3200C0E0C083C08290E6B5E04401F0D2015327");
				VendAX.Add(":0F0C420091EF90E65D7401F0D082D083D0E03264");
				VendAX.Add(":100C9D00C0E0C083C0825391EF90E65D7404F0D044");
				VendAX.Add(":060CAD0082D083D0E0328A");
				VendAX.Add(":100CB300C0E0C083C0825391EF90E65D7402F0D030");
				VendAX.Add(":060CC30082D083D0E03274");
				VendAX.Add(":100B1900C0E0C083C08290E680E030E70E85080C13");
				VendAX.Add(":100B290085090D85100E85110F800C85100C851116");
				VendAX.Add(":100B39000D85080E85090F5391EF90E65D7410F04D");
				VendAX.Add(":070B4900D082D083D0E0321E");
				VendAX.Add(":100C8500C0E0C083C082D2035391EF90E65D740843");
				VendAX.Add(":080C9500F0D082D083D0E032E0");
				VendAX.Add(":100B5000C0E0C083C08290E680E030E70E85080CDC");
				VendAX.Add(":100B600085090D85100E85110F800C85100C8511DF");
				VendAX.Add(":100B70000D85080E85090F5391EF90E65D7420F006");
				VendAX.Add(":070B8000D082D083D0E032E7");
				VendAX.Add(":0109FF0032C5");
				VendAX.Add(":010D70003250");
				VendAX.Add(":010D7100324F");
				VendAX.Add(":010D7200324E");
				VendAX.Add(":010D7300324D");
				VendAX.Add(":010D7400324C");
				VendAX.Add(":010D7500324B");
				VendAX.Add(":010D7600324A");
				VendAX.Add(":010D77003249");
				VendAX.Add(":010D78003248");
				VendAX.Add(":010D79003247");
				VendAX.Add(":010D7A003246");
				VendAX.Add(":010D7B003245");
				VendAX.Add(":010D7C003244");
				VendAX.Add(":010D7D003243");
				VendAX.Add(":010D7E003242");
				VendAX.Add(":010D7F003241");
				VendAX.Add(":010D80003240");
				VendAX.Add(":010D8100323F");
				VendAX.Add(":010D8200323E");
				VendAX.Add(":010D8300323D");
				VendAX.Add(":010D8400323C");
				VendAX.Add(":010D8500323B");
				VendAX.Add(":010D8600323A");
				VendAX.Add(":010D87003239");
				VendAX.Add(":010D88003238");
				VendAX.Add(":010D89003237");
				VendAX.Add(":010D8A003236");
				VendAX.Add(":010D8B003235");
				VendAX.Add(":010D8C003234");
				VendAX.Add(":010D8D003233");
				VendAX.Add(":010D8E003232");
				VendAX.Add(":010D8F003231");
				VendAX.Add(":010D90003230");
				VendAX.Add(":010D9100322F");
				VendAX.Add(":010D9200322E");
				VendAX.Add(":100A00001201000200000040B404041000000102C2");
				VendAX.Add(":100A100000010A06000200000040010009022E0049");
				VendAX.Add(":100A200001010080320904000004FF0000000705F6");
				VendAX.Add(":100A30000202000200070504020002000705860208");
				VendAX.Add(":100A40000002000705880200020009022E000101D1");
				VendAX.Add(":100A50000080320904000004FF00000007050202C4");
				VendAX.Add(":100A60004000000705040240000007058602400020");
				VendAX.Add(":100A70000007058802400000040309041003430036");
				VendAX.Add(":100A80007900700072006500730073000E0345006A");
				VendAX.Add(":0C0A90005A002D005500530042000000E9");
				VendAX.Add(":100BB60090E682E030E004E020E60B90E682E0304A");
				VendAX.Add(":100BC600E119E030E71590E680E04401F07F147EFD");
				VendAX.Add(":0C0BD600001207AD90E680E054FEF02213");
				VendAX.Add(":100B870030040990E680E0440AF0800790E680E0B0");
				VendAX.Add(":100B97004408F07FDC7E051207AD90E65D74FFF038");
				VendAX.Add(":0F0BA70090E65FF05391EF90E680E054F7F02274");
				VendAX.Add(":1007AD008E3A8F3B90E600E054187012E53B240121");
				VendAX.Add(":1007BD00FFE4353AC313F53AEF13F53B801590E698");
				VendAX.Add(":1007CD0000E05418FFBF100BE53B25E0F53BE53A83");
				VendAX.Add(":1007DD0033F53AE53B153BAE3A7002153A4E6005DE");
				VendAX.Add(":0607ED00120C2180EE2237");
				VendAX.Add(":020BE200A90761");
				VendAX.Add(":100BE400AE14AF158F828E83A3E064037017AD013A");
				VendAX.Add(":100BF40019ED7001228F828E83E07C002FFDEC3E84");
				VendAX.Add(":080C0400FEAF0580DFE4FEFFF6");
				VendAX.Add(":010C0C0022C5");
				VendAX.Add(":100C0D0090E682E044C0F090E681F0438701000059");
				VendAX.Add(":040C1D0000000022B1");
				VendAX.Add(":100C21007400F58690FDA57C05A3E582458370F9E6");
				VendAX.Add(":010C310022A0");
				VendAX.Add(":03004300020800B0");
				VendAX.Add(":03005300020800A0");
				VendAX.Add(":10080000020C3200020CB300020C9D00020C8500A9");
				VendAX.Add(":10081000020B1900020B50000209FF00020D7000CC");
				VendAX.Add(":10082000020D7100020D7200020D7300020D7400C2");
				VendAX.Add(":10083000020D7500020D7600020D7700020D7800A2");
				VendAX.Add(":10084000020D7900020D7000020D7A00020D7B008E");
				VendAX.Add(":10085000020D7C00020D7D00020D7E00020D7F0066");
				VendAX.Add(":10086000020D8000020D7000020D7000020D70007C");
				VendAX.Add(":10087000020D8100020D8200020D8300020D840032");
				VendAX.Add(":10088000020D8500020D8600020D8700020D880012");
				VendAX.Add(":10089000020D8900020D8A00020D8B00020D8C00F2");
				VendAX.Add(":1008A000020D8D00020D8E00020D8F00020D9000D2");
				VendAX.Add(":0808B000020D9100020D9200FF");
				VendAX.Add(":0A0A9C008E3C8F3D8C3E8D3F8B4059");
				VendAX.Add(":100AA600C28743B280120D58120D24120CC950048D");
				VendAX.Add(":100AB600D2048059E519600FE53C90E679F0120CF6");
				VendAX.Add(":100AC600C95004D2048046E53D90E679F0120CC97F");
				VendAX.Add(":100AD6005004D2048037E4F541E541C395405021E6");
				VendAX.Add(":100AE600053FE53FAE3E7002053E14F5828E83E07B");
				VendAX.Add(":100AF60090E679F0120D145004D20480100541805E");
				VendAX.Add(":100B0600D890E678E04440F0120C51C20453B27F0C");
				VendAX.Add(":020B1600A20437");
				VendAX.Add(":010B180022BA");
				VendAX.Add(":0F0D240090E6787480F0E51725E090E679F022EC");
				VendAX.Add(":100C5100120D58120D24120D1490E678E04440F064");
				VendAX.Add(":0A0C6100120D5890E678E030E1E94A");
				VendAX.Add(":010C6B002266");
				VendAX.Add(":080D580090E678E020E6F922A4");
				VendAX.Add(":0A08B8008E3C8F3D8D3E8A3F8B4041");
				VendAX.Add(":1008C200120D58120D24120CC9500122E519600CA8");
				VendAX.Add(":1008D200E53C90E679F0120CC9500122E53D90E624");
				VendAX.Add(":1008E20079F0120CC950012290E6787480F0E51775");
				VendAX.Add(":1008F20025E0440190E679F0120D1450012290E6B1");
				VendAX.Add(":1009020079E0F541120D14500122E4F541E53E145F");
				VendAX.Add(":10091200FFE541C39F501C90E679E0FFE540254189");
				VendAX.Add(":10092200F582E4353FF583EFF0120D1450012205F4");
				VendAX.Add(":100932004180DA90E6787420F0120D145001229072");
				VendAX.Add(":10094200E679E0FFE5402541F582E4353FF583EFA6");
				VendAX.Add(":10095200F0120D1450012290E6787440F090E6797E");
				VendAX.Add(":04096200E0F541C3B8");
				VendAX.Add(":01096600226E");
				VendAX.Add(":0F0D140090E678E0FF30E0F8EF30E202D322C340");
				VendAX.Add(":010D230022AD");
				VendAX.Add(":100CC90090E678E0FF30E0F8EF30E202D322EF203F");
				VendAX.Add(":050CD900E102D322C37B");
				VendAX.Add(":010CDE0022F3");
				VendAX.Add(":10096700E51970037F01227A107B407D40E4FFFE8A");
				VendAX.Add(":100977001208B8E4F53A7400253AF582E43410F524");
				VendAX.Add(":1009870083E53AF0053AE53AB440EB7C107D007B0D");
				VendAX.Add(":1009970040E4FFFE120A9CE4F53AE53AF4FF7400DE");
				VendAX.Add(":1009A700253AF582E43410F583EFF0053AE53AB4D9");
				VendAX.Add(":1009B70040E87A107B007D40E4FFFE1208B89010F3");
				VendAX.Add(":1009C70000E0F53AE53A30E005753B018008633A07");
				VendAX.Add(":1009D7003F053A853A3BE4F53AE53AC3944050156A");
				VendAX.Add(":1009E700AF3A7E007C107D40AB3B120A9CE53B256D");
				VendAX.Add(":0709F7003AF53A80E4AF3B42");
				VendAX.Add(":0109FE0022D6");
				VendAX.Add(":030000000207F301");
				VendAX.Add(":0C07F300787FE4F6D8FD75814102064DC8");
				VendAX.Add(":100D0300EB9FF5F0EA9E42F0E99D42F0E89C45F046");
				VendAX.Add(":010D130022BD");
				VendAX.Add(":00000001FF");
			}
			else																	//Vend_ax firmware for older part numbers of EZ-USB family (FX, AN2131 etc) provided just for reference)
			{
				VendAX.Add(":1005B200E4F52CF52BF52AF529C203C200C202C2CA");
				VendAX.Add(":1005C20001120D0C7E087F888E088F09750A087546");
				VendAX.Add(":1005D2000B9A750C08750DBAEE54E070030206BE54");
				VendAX.Add(":1005E200752D00752E808E2F8F30C374F49FFF748B");
				VendAX.Add(":1005F200089ECF2402CF3400FEE48F288E27F526F2");
				VendAX.Add(":10060200F525F524F523F522F521AF28AE27AD26F1");
				VendAX.Add(":10061200AC25AB24AA23A922A821C312087750260D");
				VendAX.Add(":10062200E52E2524F582E52D3523F58374CDF0E5FD");
				VendAX.Add(":10063200242401F524E43523F523E43522F522E4CC");
				VendAX.Add(":100642003521F52180C4E4F524F523F522F521AF07");
				VendAX.Add(":1006520028AE27AD26AC25AB24AA23A922A821C304");
				VendAX.Add(":100662001208775031AE23AF24E5302FF582E52F03");
				VendAX.Add(":100672003EF583E0FDE52E2FF582E52D3EF583ED77");
				VendAX.Add(":10068200F0EF2401F524E43EF523E43522F522E4DB");
				VendAX.Add(":100692003521F52180B9852D08852E09748824809D");
				VendAX.Add(":1006A200FF740834FFFEC3E50B9FF50BE50A9EF5C8");
				VendAX.Add(":1006B2000AC3E50D9FF50DE50C9EF50CD2E843D873");
				VendAX.Add(":1006C20020907F95E044C0F0907FAFE04401F0902D");
				VendAX.Add(":1006D2007FAEE0441DF0D2AF538EF8300105120018");
				VendAX.Add(":1006E20080C20130031A1208FE5015C203120C61B7");
				VendAX.Add(":1006F200200007907FD6E020E7F3120CBA120D1506");
				VendAX.Add(":05070200120D1F80D65E");
				VendAX.Add(":10008000907FE9E0700302021B14700302029724C0");
				VendAX.Add(":10009000FE700302030E24FB7003020215147003AA");
				VendAX.Add(":1000A00002020F14700302020314700302020924F7");
				VendAX.Add(":1000B000056003020362120D17400302036E907F76");
				VendAX.Add(":1000C000EBE024FE6019146045240260030201F98C");
				VendAX.Add(":1000D000E508907FD4F0E509907FD5F002036E909B");
				VendAX.Add(":1000E0007FEAE0FF120A3CAA06A9077B018B318A4E");
				VendAX.Add(":1000F000328933EA49600DEE907FD4F0EF907FD5DE");
				VendAX.Add(":10010000F002036E907FB4E04401F002036E907F32");
				VendAX.Add(":10011000EAE0FF120B4FAA06A9077B018B318A3256");
				VendAX.Add(":090120008933EA4970030201EF82");
				VendAX.Add(":10012900AB318B388A39893A12080FF53B907FEE4B");
				VendAX.Add(":10013900E0FFE53BD39F4003E0F53BE53B7003025D");
				VendAX.Add(":1001490001E1E4F537F536F535F534E53BC394407F");
				VendAX.Add(":100159005004AF3B80027F40E4FCFDFEAB37AA367A");
				VendAX.Add(":10016900A935A834C31208775032E53A2537F58204");
				VendAX.Add(":10017900E5393536F583E0FF74002537F582E43437");
				VendAX.Add(":100189007FF583EFF0E5372401F537E43536F536A9");
				VendAX.Add(":10019900E43535F535E43534F53480AFE53BC394C2");
				VendAX.Add(":1001A900405004AF3B80027F40907FB5EFF0E53BC4");
				VendAX.Add(":1001B900C394405004AF3B80027F40C3E53B9FF5A9");
				VendAX.Add(":1001C9003B7440253AF53AE43539F539907FB4E086");
				VendAX.Add(":1001D90020E20302014480F4E4907FB5F0907FB4FB");
				VendAX.Add(":0301E9007402F0AD");
				VendAX.Add(":1001EC0002036E907FB4E04401F002036E907FB482");
				VendAX.Add(":1001FC00E04401F002036E120CE202036E120CFCDE");
				VendAX.Add(":10020C0002036E1208F602036E120CD402036E1275");
				VendAX.Add(":10021C000D19400302036E907FE8E0247F602414E4");
				VendAX.Add(":10022C0060312402705BA200E433FF25E0FFA202E0");
				VendAX.Add(":10023C00E4334F907F00F0E4A3F0907FB57402F0AC");
				VendAX.Add(":10024C0002036EE4907F00F0A3F0907FB57402F08F");
				VendAX.Add(":10025C0002036E907FECE0F45480FFC4540FFFE077");
				VendAX.Add(":10026C0054072F25E024B4F582E4347FF583E05461");
				VendAX.Add(":10027C0001907F00F0E4A3F0907FB57402F00203CC");
				VendAX.Add(":10028C006E907FB4E04401F002036E120D1B40032C");
				VendAX.Add(":10029C0002036E907FE8E024FE601D2402600302DE");
				VendAX.Add(":1002AC00036E907FEAE0B40105C20002036E907FFA");
				VendAX.Add(":1002BC00B4E04401F002036E907FEAE0703B907F63");
				VendAX.Add(":1002CC00ECE0F45480FFC4540FFFE054072F25E0FA");
				VendAX.Add(":1002DC0024B4F582E4347FF583E4F0907FECE054B1");
				VendAX.Add(":1002EC0080FF131313541FFFE054072F907FD7F098");
				VendAX.Add(":0302FC00E4F538EE");
				VendAX.Add(":1002FF00E04420F08069907FB4E04401F080601208");
				VendAX.Add(":10030F000D1D505B907FE8E024FE60182402704FB3");
				VendAX.Add(":10031F00907FEAE0B40104D2008044907FB4E044BF");
				VendAX.Add(":10032F0001F0803B907FEAE07020907FECE0F45486");
				VendAX.Add(":10033F0080FFC4540FFFE054072F25E024B4F5824B");
				VendAX.Add(":10034F00E4347FF5837401F08015907FB4E04401AD");
				VendAX.Add(":10035F00F0800C1203765007907FB4E04401F090C8");
				VendAX.Add(":06036F007FB4E04402F03F");
				VendAX.Add(":010375002265");
				VendAX.Add(":03003300020D11AA");
				VendAX.Add(":040D110053D8EF3292");
				VendAX.Add(":1008880012010001000000404705021001000102AA");
				VendAX.Add(":10089800000109022000010100A000090400000273");
				VendAX.Add(":1008A800FF00000007058202400000070502024021");
				VendAX.Add(":1008B8000000040309041A0341006E006300680085");
				VendAX.Add(":1008C8006F00720020004300680069007000730028");
				VendAX.Add(":1008D8001C0345005A002D0055005300420020001B");
				VendAX.Add(":0E08E8004400650076006900630065000000B2");
				VendAX.Add(":050D0C00D200020D04FD");
				VendAX.Add(":010D1F0022B1");
				VendAX.Add(":0208FE00D32203");
				VendAX.Add(":020D1500D322E7");
				VendAX.Add(":020D1700D322E5");
				VendAX.Add(":0808F600907FEAE0F516D32221");
				VendAX.Add(":0E0CD400907F00E516F0907FB57401F0D322FA");
				VendAX.Add(":080CFC00907FEAE0F514D32219");
				VendAX.Add(":0E0CE200907F00E514F0907FB57401F0D322EE");
				VendAX.Add(":020D1900D322E3");
				VendAX.Add(":020D1B00D322E1");
				VendAX.Add(":020D1D00D322DF");
				VendAX.Add(":10037600907FA5E05410FFC4540F4450F51513E4C4");
				VendAX.Add(":1003860033F517907FE9E0245EB4080040030205C8");
				VendAX.Add(":10039600B090039EF828287302042F02042F02034C");
				VendAX.Add(":1003A600FE0203B60203CC0203E802040702042994");
				VendAX.Add(":1003B600907F00E517F0907FB57401F0907FB4E070");
				VendAX.Add(":1003C6004402F00205B0907F92E0FFC4540F907F84");
				VendAX.Add(":1003D60000F0907FB57401F0907FB4E04402F00223");
				VendAX.Add(":1003E60005B0907F00740FF0907FB57401F0907F98");
				VendAX.Add(":1003F600B4E04402F00205B0907FEAE0F51502058C");
				VendAX.Add(":10040600B0907F007407F0907FB57401F0907FB4D0");
				VendAX.Add(":10041600E04402F07FE87E03120B7BD204120958F7");
				VendAX.Add(":100426000205B0751701431501907FEAE0753C009F");
				VendAX.Add(":10043600F53DA3E0FEE4EE423C907FEEE0753E0023");
				VendAX.Add(":10044600F53FA3E0FEE4EE423E907FE8E064C06044");
				VendAX.Add(":100456000302051CE53F453E70030205B0C3E53FB8");
				VendAX.Add(":100466009440E53E94005008853E40853F41800615");
				VendAX.Add(":10047600754000754140907FE9E0B4A335E4F5424C");
				VendAX.Add(":10048600F543C3E5439541E54295405060E53D257A");
				VendAX.Add(":1004960043F582E53C3542F583E0FF74002543F5DC");
				VendAX.Add(":1004A60082E4347FF583EFF00543E54370D40542DB");
				VendAX.Add(":1004B60080D0E4F542F543C3E5439541E5429540D6");
				VendAX.Add(":1004C600501874002543F582E4347FF58374CDF02B");
				VendAX.Add(":1004D6000543E54370E1054280DDAD417A7F790051");
				VendAX.Add(":1004E6007E7F7F00AB07AF3DAE3C1209A9907FB57A");
				VendAX.Add(":1004F600E541F0253DF53DE540353CF53CC3E53F9E");
				VendAX.Add(":100506009541F53FE53E9540F53E907FB4E020E20B");
				VendAX.Add(":100516000302045A80F4907FE8E064406003020519");
				VendAX.Add(":10052600B0E53F453E70030205B0E4907FC5F0900C");
				VendAX.Add(":100536007FB4E020E3F9907FC5E0754000F5419077");
				VendAX.Add(":100546007FE9E0B4A335E4F542F543C3E5439541BD");
				VendAX.Add(":10055600E5429540503874C02543F582E4347EF573");
				VendAX.Add(":1005660083E0FFE53D2543F582E53C3542F583EF23");
				VendAX.Add(":10057600F00543E54370D4054280D0AD417A7E79DB");
				VendAX.Add(":10058600C07E7E7FC0AB07AF3DAE3C120AB4E541EC");
				VendAX.Add(":10059600253DF53DE540353CF53CC3E53F9541F548");
				VendAX.Add(":0B05A6003FE53E9540F53E020527C3EF");
				VendAX.Add(":0105B1002227");
				VendAX.Add(":100BA400C0E0C083C082C085C084C086758600D280");
				VendAX.Add(":100BB400015391EF907FAB7401F0D086D084D0853F");
				VendAX.Add(":070BC400D082D083D0E032A3");
				VendAX.Add(":100BF200C0E0C083C082C085C084C08675860053B1");
				VendAX.Add(":100C020091EF907FAB7404F0D086D084D085D082EF");
				VendAX.Add(":050C1200D083D0E032A8");
				VendAX.Add(":100C1700C0E0C083C082C085C084C086758600538B");
				VendAX.Add(":100C270091EF907FAB7402F0D086D084D085D082CC");
				VendAX.Add(":050C3700D083D0E03283");
				VendAX.Add(":100C3C00C0E0C083C082C085C084C0867586005366");
				VendAX.Add(":100C4C0091EF907FAB7410F0D086D084D085D08299");
				VendAX.Add(":050C5C00D083D0E0325E");
				VendAX.Add(":010D200032A0");
				VendAX.Add(":100BCB00C0E0C083C082C085C084C086758600D259");
				VendAX.Add(":100BDB00035391EF907FAB7408F0D086D084D0850F");
				VendAX.Add(":070BEB00D082D083D0E0327C");
				VendAX.Add(":010D2100329F");
				VendAX.Add(":010D2200329E");
				VendAX.Add(":010D2300329D");
				VendAX.Add(":010D2400329C");
				VendAX.Add(":010D2500329B");
				VendAX.Add(":010D2600329A");
				VendAX.Add(":010D27003299");
				VendAX.Add(":010D28003298");
				VendAX.Add(":010D29003297");
				VendAX.Add(":010D2A003296");
				VendAX.Add(":010D2B003295");
				VendAX.Add(":010D2C003294");
				VendAX.Add(":010D2D003293");
				VendAX.Add(":010D2E003292");
				VendAX.Add(":010D2F003291");
				VendAX.Add(":010D30003290");
				VendAX.Add(":100D3100AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA12");
				VendAX.Add(":100D4100AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA02");
				VendAX.Add(":100D5100AAAAAAAAAAAAAAAAAAAAAA000000000044");
				VendAX.Add(":100D61000000000000000000000000000000000082");
				VendAX.Add(":0F0D710000000000000000000000000000000071");
				VendAX.Add(":0609F300AB07AA06AC05EB");
				VendAX.Add(":1009F900E4FDE5176010EA7E000DEE2400F582E4BF");
				VendAX.Add(":100A0900340EF583EAF0EBAE050D74002EF582E4A1");
				VendAX.Add(":100A1900340EF583EBF0AF050D74002FF582E43445");
				VendAX.Add(":100A29000EF583ECF07A0E7B00AF15120C9EAF1514");
				VendAX.Add(":030A3900020A7E30");
				VendAX.Add(":0A0AB4008E448F458D468A478B481B");
				VendAX.Add(":100ABE00E4F549E549C3954650200545E545AE4464");
				VendAX.Add(":100ACE007002054414FFE5482549F582E43547F5E3");
				VendAX.Add(":0A0ADE0083E0FD1209F3054980D9F9");
				VendAX.Add(":010AE80022EB");
				VendAX.Add(":0A09A9008E448F458D468A478B4827");
				VendAX.Add(":1009B300E4FDF549E5176012E544FF7E000DEE24E2");
				VendAX.Add(":1009C30000F582E4340EF583EFF0E545AE050D74D2");
				VendAX.Add(":1009D300002EF582E4340EF583E545F07A0E7B00B4");
				VendAX.Add(":1009E300AF15120C9EAB48AA47AD46AF15020C8259");
				VendAX.Add(":03004300020900AF");
				VendAX.Add(":10090000020BA400020C1700020BF200020BCB003A");
				VendAX.Add(":10091000020C3C00020D2000020D2100020D2200FD");
				VendAX.Add(":10092000020D2300020D2400020D2500020D2600F9");
				VendAX.Add(":10093000020D2700020D2800020D2900020D2A00D9");
				VendAX.Add(":10094000020D2B00020D2C00020D2D00020D2E00B9");
				VendAX.Add(":08095000020D2F00020D300022");
				VendAX.Add(":100CBA00907FD6E030E712E04401F07F147E001204");
				VendAX.Add(":0A0CCA000B7B907FD6E054FEF02271");
				VendAX.Add(":100C6100907FD6E04480F04387010000000000221D");
				VendAX.Add(":07095800907FD6E04408F097");
				VendAX.Add(":03095F00E4F54478");
				VendAX.Add(":04096200E054FBF072");
				VendAX.Add(":03096600E4F54471");
				VendAX.Add(":10096900E04408F0300404E04402F07FDC7E051224");
				VendAX.Add(":100979000B7B907F92E030E3077FDC7E05120B7BD7");
				VendAX.Add(":10098900907FAB74FFF0907FA9F0907FAAF053910C");
				VendAX.Add(":08099900EF907FD6E054F7F067");
				VendAX.Add(":0309A100E4F54436");
				VendAX.Add(":0509A400E04404F02214");
				VendAX.Add(":100B7B008E458F46907F92E030E30BE54625E0F5FE");
				VendAX.Add(":100B8B0046E54533F545E5461546AE457002154538");
				VendAX.Add(":090B9B004E6005120C7180EE227F");
				VendAX.Add(":080D0400E4F513D2E9D2AF229D");
				VendAX.Add(":100A7E00907FA5E020E6F9C2E9907FA5E04480F0E2");
				VendAX.Add(":100A8E00EF25E0907FA6F0907FA5E030E0F9907F13");
				VendAX.Add(":100A9E00A5E04440F0907FA5E020E6F9907FA5E028");
				VendAX.Add(":060AAE0030E1D6D2E9227E");
				VendAX.Add(":100B1D00A907907FA5E020E6F9E5137023907FA546");
				VendAX.Add(":100B2D00E04480F0E925E0907FA6F08D0EAF03A99B");
				VendAX.Add(":100B3D0007750F018A108911E4F512751301D3227F");
				VendAX.Add(":020B4D00C322C1");
				VendAX.Add(":100AE900A907907FA5E020E6F9E5137025907FA579");
				VendAX.Add(":100AF900E04480F0E925E04401907FA6F08D0EAF37");
				VendAX.Add(":100B090003A907750F018A108911E4F512751303FA");
				VendAX.Add(":040B1900D322C322FE");
				VendAX.Add(":03004B00020707A2");
				VendAX.Add(":10070700C0E0C083C082C085C084C086758600C033");
				VendAX.Add(":10071700D075D000C000C001C002C003C006C0072A");
				VendAX.Add(":10072700907FA5E030E2067513060207F1907FA5DA");
				VendAX.Add(":10073700E020E10CE513640260067513070207F178");
				VendAX.Add(":10074700E51324FE605F14603624FE70030207E29F");
				VendAX.Add(":1007570024FC70030207EE240860030207F1AB0FC5");
				VendAX.Add(":10076700AA10A911AF1205128F82758300120828EB");
				VendAX.Add(":10077700907FA6F0E512650E7070751305806B907B");
				VendAX.Add(":100787007FA6E0AB0FAA10A911AE128E8275830067");
				VendAX.Add(":10079700120855751302E50E6401704E907FA5E0AF");
				VendAX.Add(":1007A7004420F08045E50E24FEB51207907FA5E0B2");
				VendAX.Add(":1007B7004420F0E50E14B5120A907FA5E04440F0FE");
				VendAX.Add(":1007C700751300907FA6E0AB0FAA10A911AE128E89");
				VendAX.Add(":1007D700827583001208550512800F907FA5E044AB");
				VendAX.Add(":1007E70040F075130080037513005391DFD007D0D5");
				VendAX.Add(":1007F70006D003D002D001D000D0D0D086D084D08C");
				VendAX.Add(":0808070085D082D083D0E032DD");
				VendAX.Add(":020B4F00A907F4");
				VendAX.Add(":100B5100AE0CAF0D8F828E83A3E064037017AD01DD");
				VendAX.Add(":100B610019ED7001228F828E83E07C002FFDEC3E17");
				VendAX.Add(":090B7100FEAF0580DF7E007F006D");
				VendAX.Add(":010B7A002258");
				VendAX.Add(":100A3C00E4FEAC0AAD0B8D828C83A3E06402702DB6");
				VendAX.Add(":100A4C00AB060EEBB50705AF05AE04228D828C8389");
				VendAX.Add(":100A5C00A3A3E0F53CA3E0F53D623CE53C623DE53B");
				VendAX.Add(":100A6C003D623C2DFBE53C3CFCAD0380C97E007F28");
				VendAX.Add(":010A7C000079");
				VendAX.Add(":010A7D002256");
				VendAX.Add(":100C8200120AE9E51324FA600E146006240770F3D1");
				VendAX.Add(":0C0C9200D322E4F513D322E4F513D3229F");
				VendAX.Add(":100C9E00120B1DE51324FA600E146006240770F380");
				VendAX.Add(":0C0CAE00D322E4F513D322E4F513D32283");
				VendAX.Add(":100C71007400F58690FDA57C05A3E582458370F996");
				VendAX.Add(":010C81002250");
				VendAX.Add(":03000000020CF0FF");
				VendAX.Add(":0C0CF000787FE4F6D8FD7581490205B25A");
				VendAX.Add(":10080F00BB010689828A83E0225002E722BBFE02E7");
				VendAX.Add(":09081F00E32289828A83E493221A");
				VendAX.Add(":10082800BB010CE58229F582E5833AF583E0225085");
				VendAX.Add(":1008380006E92582F8E622BBFE06E92582F8E222CF");
				VendAX.Add(":0D084800E58229F582E5833AF583E49322E9");
				VendAX.Add(":10085500F8BB010DE58229F582E5833AF583E8F0D9");
				VendAX.Add(":10086500225006E92582C8F622BBFE05E92582C885");
				VendAX.Add(":02087500F2226D");
				VendAX.Add(":10087700EB9FF5F0EA9E42F0E99D42F0E89C45F0D7");
				VendAX.Add(":01088700224E");
				VendAX.Add(":00000001FF");
			}
		}

		void Firmware_download(String^ file)									//Function which takes firmware file as input and downloads firmware
		{
			long recordlength, recordaddress, recordtype;
			StreamReader^ rd;
			String^ line;
			BYTE checksum, recordchecksum;
			int i;
			char tmp[5] = {};
			BYTE *Image,*ImageMap;
			unsigned char buf[RECORDSIZE] = {};
			long bufLen;
			Image = (BYTE *)malloc(MEMORY_BUFFER_SIZE);							//Temporary buffers used for storing the parsed firmware
			ImageMap = (BYTE *)malloc(MEMORY_BUFFER_SIZE);
			memset(Image,MEM_FILL,MEMORY_BUFFER_SIZE);
			memset(ImageMap,FALSE,MEMORY_BUFFER_SIZE);

			if(file != "VendAX")
			{
				try
				{
					rd = gcnew StreamReader(file);								//Handle to firmware (*.hex file)
				}
				catch(System::Exception^ e)										//Exception handle to catch access error which occurs when the firmware (*.hex)
																				//is open in another editor which restricts opening a handle
				{
					Error(ERR_INFILE);
				}
				VendAX.Clear();
				while(line = rd->ReadLine())
				{
					VendAX.Add(line);
				}
			}
			else
			{
				VendAX.Clear();
				InitVendAX(FX2LP);
			}
			ArrayList FirmwareBuffer = gcnew ArrayList(%VendAX);
			for each(line in FirmwareBuffer)									//Parsing the intel-hex file to store firmware in an array
			{
				if(line[0] != ':')
					Error(ERR_INVALID_FILE);
				tmp[0] = (char)line[1];
				tmp[1] = (char)line[2];
				tmp[2] = 0;
				recordlength = (BYTE)strtol(tmp,0,16);
				tmp[0] = (char)line[3];
				tmp[1] = (char)line[4];
				tmp[2] = (char)line[5];
				tmp[3] = (char)line[6];
				tmp[4] = 0;
				recordaddress = (WORD)strtol(tmp,0,16);
				tmp[0] = (char)line[7];
				tmp[1] = (char)line[8];
				tmp[2] = 0;
				recordtype = (BYTE)strtol(tmp,NULL,16);

				if(recordtype == 1)
					break;
				checksum = 0;
				checksum = (BYTE) (recordlength + (BYTE)recordaddress + (BYTE)(recordaddress>>8) + recordtype);
				for(i=0;i < recordlength; ++i)
				{
					 tmp[0] = (char)line[(i*2)+9];
					 tmp[1] = (char)line[(i*2)+10];
					 tmp[2] = 0;
					 Image[recordaddress+i] = (BYTE)strtol(tmp,0,16);
					 checksum += Image[recordaddress+i];
					 ImageMap[recordaddress+i] = TRUE;
				}
				checksum = (~checksum) + 1;
				tmp[0] = (char)line[(i*2)+9];
				tmp[1] = (char)line[(i*2)+10];
				tmp[2] = 0;
				recordchecksum = (BYTE)strtol(tmp,NULL,16);
				if(recordchecksum != checksum)
					Error(ERR_BAD_CHKSUM);
			}
			for(i= MAX_INTERNAL_MEMORY; i < MEMORY_BUFFER_SIZE;i++)							//If memory location greater than internal On chip memory size use 0xA3 vendor request
			{
				if(ImageMap[i])
				{
					if(FirstTime)
					{
						FirstTime = FALSE;
						Download_Data->AppendText("Downloading Vend_AX firmware" + Environment::NewLine);	
						Firmware_download("VendAX");
					}
					ept->Value = i;
					ept->ReqCode = 0xA3;
					bufLen = 0;
					memset(buf,FALSE,RECORDSIZE);
					int j = 0;
					Download_Data->AppendText("Vendor Request (" + String::Format("{0:X2}",ept->ReqCode) + ") Address = 0x" + 
						Convert::ToString(ept->Value,16));									
					while((ImageMap[i]) && (i < MEMORY_BUFFER_SIZE))
					{
						if(!(j%16))
							Download_Data->AppendText(Environment::NewLine + String::Format("{0:X4}",j) + "  ");
						buf[j] = Image[i++];
						Download_Data->AppendText(String::Format("{0:X2}",buf[j++]) + " ");		//Print the memory location and value being downloaded
						bufLen++;
					}
					Download_Data->AppendText(Environment::NewLine);
					ept->XferData((PUCHAR)buf,bufLen);
				}
			}
			CPU_Reset(TRUE);
			for(i = 0; i < MAX_INTERNAL_MEMORY; i++)											//If memory location lesser than internal On chip memory size use 0xA0 vendor request
			{
				ept->ReqCode = 0xA0;
				bufLen = 0;
				memset(buf,FALSE,RECORDSIZE);
				if(ImageMap[i])
				{
					ept->Value = i;
					int j = 0;
					Download_Data->AppendText("Vendor Request (" + String::Format("{0:X2}",ept->ReqCode) + ") Address = 0x" + 
						String::Format("{0:X4}",ept->Value));
					while((ImageMap[i]) && (i < MAX_INTERNAL_MEMORY))
					{
						if(!(j%16))
							Download_Data->AppendText(Environment::NewLine + String::Format("{0:X4}",j) + "  ");	//Print the memory location and value being downloaded
						buf[j] = Image[i++];
						Download_Data->AppendText(String::Format("{0:X2}",buf[j++]) + " ");
						bufLen++;
					}
					Download_Data->AppendText(Environment::NewLine);
					ept->XferData((PUCHAR)buf,bufLen);
				}
			}
			CPU_Reset(FALSE);
		}

		void CPU_Reset(bool ON)							//Hold CPU(8051) in Reset if ON is TRUE else run CPU
		{
			char buf[1];
			long recordlength;

			ept->Target    = TGT_DEVICE; 
			ept->ReqType   = REQ_VENDOR;				//the request type is vendor
			ept->Direction = DIR_TO_DEVICE;   
			ept->ReqCode   = 0xA0;						//Request code is A0
			ept->Value     = CPU_RESET_REGISTER;        //address of register CPUCS
			ept->Index     = 0; 
			buf[0]= ON;									// write '1' to the CPUCS register to place the CPU in reset and '0' to run CPU
			recordlength = 1;              
			Download_Data->AppendText("Toggle 8051 Reset (" + String::Format("{0:X2}",buf[0]) + ")" + Environment::NewLine);
			ept->XferData((PUCHAR)buf,  recordlength);	//issue the A0 vendor command
		}


	protected:
	  [SecurityPermission(SecurityAction::Demand, Flags=SecurityPermissionFlag::UnmanagedCode)]
      virtual void WndProc( Message% m ) override
      {

         // Listen for operating system messages and handle behavior of GUI for plug-n-play events.
			if (m.Msg == WM_DEVICECHANGE) 
			{
				// Tracks DBT_DEVNODES_CHANGED followed by DBT_DEVICEREMOVECOMPLETE
				if ((int)m.WParam == DBT_DEVNODES_CHANGED) 
				{
					bPnP_DevNodeChange = true;
					bPnP_Removal = false;
				}

				// Tracks DBT_DEVICEARRIVAL followed by DBT_DEVNODES_CHANGED
				if ((int)m.WParam == DBT_DEVICEARRIVAL) 
				{
					bPnP_Arrival = true;
					bPnP_DevNodeChange = false;
				}

				if ((int)m.WParam == DBT_DEVICEREMOVECOMPLETE) 
					bPnP_Removal = true;

				// If DBT_DEVICEARRIVAL followed by DBT_DEVNODES_CHANGED
				if (bPnP_DevNodeChange && bPnP_Removal) 
				{
					bPnP_Removal = false;
					bPnP_DevNodeChange = false;
					GetDevice();
				}

				// If DBT_DEVICEARRIVAL followed by DBT_DEVNODES_CHANGED
				if (bPnP_DevNodeChange && bPnP_Arrival) 
				{
					bPnP_Arrival = false;
					bPnP_DevNodeChange = false;
					GetDevice();
				}

			}
         Form::WndProc( m );
      }

	private: System::Void Device_List_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
				 Selected_Index = Device_List->SelectedIndex;
				 USBDevice->Open(Selected_Index);
			 }
private: System::Void FX2LP_OR_FX_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
			 if(FX2LP_OR_FX->SelectedIndex == 0)							//Select memory location of CPUCS register based on target device
			 {
				 FX2LP = TRUE;
				 CPU_RESET_REGISTER = 0xE600;
			 }
			 else
			 {
				 FX2LP = FALSE;
				 CPU_RESET_REGISTER = 0x7F92;
			 }
		 }
private: System::Void Clear_Click(System::Object^  sender, System::EventArgs^  e) {
			 Download_Data->Clear();										//Clear the Download_Data textbox
		 }
};
}

